;********************************************************************
;	SHOWPSP.ASM - display the interesting data areas in the Program
;	Segment Prefix data area
;
;	To assemble: ml /DMEMORY_MODEL=small showpsp.asm hex.asm
;********************************************************************


	title	psp.asm
	name	psp
	.model	MEMORY_MODEL
	.dosseg

	include	STDMAC.INC

	.stack

CRLF	textequ <0dh, 0ah>
ENDLIST	textequ <0ffffh>


;--------------------------------------------------------------------
;	printStr - macro to print a string
;
printStr macro offs:REQ, segreg

	IFNB <segreg>
		push	ds
		mov 	dx, segreg
		mov 	ds, dx
	ENDIF
	mov 	dx, offset offs
	dosSVC	9
	IFNB <segreg>
		pop 	ds
	ENDIF

endm

;--------------------------------------------------------------------
;	printLine - macro to print a string and a numeric value. The
;	value can be a BYTE, WORD, or DWORD
;
printLine macro string, type, address

	mov 	dx, offset string
	dosSVC	9
	IF type EQ BYTE
		mov al,es:[address]
		call hexout$b
	ELSEIF type EQ WORD
		mov ax,es:[address]
		call hexout$w
	ELSEIF type EQ DWORD
		mov ax,es:[address]
		mov dx,es:[address+2]
		call hexout$d
	ENDIF

endm


	;-----------------;
	; Local data area ;
	;-----------------;
	.data

m$PSPseg	db	CRLF, '         Current PSP segment is - $'
m$segend	db	CRLF, '       Last segment of PSP seg  - $'
m$oldInt22	db	CRLF, '              Terminate address - $'
m$oldInt23	db	CRLF, '          ^Break exit address   - $'
m$oldInt24	db	CRLF, '    Critical error exit address - $'
m$parPSPseg db	CRLF, "                   Parent's PSP - $"
m$segEnv	db	CRLF, '         Segment of environment - $'
m$INT21stak db	CRLF, ' Stack contents at last INT 21H - $'
m$numFiles	db	CRLF, '         Number of file handles - $'
m$ftabaddr	db	CRLF, '          Address of file table - $'
m$parPSPptr db	CRLF, "        Pointer to parent's PSP - $"
m$FCB1		db	CRLF, '                 Default file 1 - $'
m$FCB2		db	CRLF, '                 Default file 2 - $'
m$CMDlen	db	CRLF, 'Characters in command line tail - $'
m$CMDtail	db	CRLF, 'Command tail: $'
m$fileTbl	db	CRLF, 'File handle table:', CRLF, '	 $'
m$BadType	db	'Undefined type specifier'

	;-----------;
	; Code area ;
	;-----------;
	.code
	.startup

	mov 	al, '$' 			; String terminator
	mov 	es:[68h], al		; Terminate FCB 1 file name
	mov 	es:[78h], al		; Terminate FCB 2 file name
	mov 	bl, es:[80h]		; Terminate command tail
	xor 	bh, bh
	add 	bx, 81h
	mov 	es:[bx], al

	printStr	m$PSPseg
	mov 		ax, es
	call		hexout$w
	printLine	m$segend,		WORD,	02h
	printLine	m$oldInt22, 	DWORD,	0ah
	printLine	m$oldInt23, 	DWORD,	0eh
	printLine	m$oldInt24, 	DWORD,	12h
	printLine	m$parPSPseg,	WORD,	16h
	printLine	m$segEnv,		WORD,	2ch
	printLine	m$INT21stak,	DWORD,	2eh
	printLine	m$numFiles, 	WORD,	32h
	printLine	m$ftabaddr, 	DWORD,	34H
	printLine	m$parPSPptr,	DWORD,	38H
	printStr	m$FCB1
	printStr	5dh, es
	printStr	m$FCB2
	printStr	6dh, es
	printLine	m$CMDlen,		BYTE,	80H
	printStr	m$CMDtail
	printStr	81H, es


	printStr	m$fileTbl		; Print the table of file handles
	mov 	cx, 20
	les 	bx, es:[34h]
@@:
	mov 	al, es:[bx]
	call	hexout$b
	mov 	dl, ' '
	dosSVC	2
	inc 	bx
	loop	@B

	.exit	0					; Exit program

;--------------------------------------------------------------------
; strprint - print the indicated string
;
;	INP:	DS:DX - address of string to print
;
strprint:
	mov	ah,09h
	int	21h
	ret

extern	hexout$b:proc, hexout$w:proc, hexout$d:proc

	end
